#include <irrlicht.h>
#include <iostream>
#include <LIST>

using namespace irr;

#pragma comment(lib, "Irrlicht.lib")

static int jikix=320, jikiy=240;
static int tamax=0, tamay=-999;
static int tekix=320, tekiy=0;

static bool left=false, right=false, up=false, down=false;
static bool button1=false, canFire=true;

class MyEventReceiver : public IEventReceiver
{
public:
	virtual bool OnEvent(SEvent event)
	{
		if (event.EventType == irr::EET_KEY_INPUT_EVENT)
		{
			if (event.KeyInput.PressedDown)
			{
				switch(event.KeyInput.Key)
				{
				case KEY_ESCAPE:
					exit(0);

				case KEY_LEFT:
					left = true;
					return true;

				case KEY_RIGHT:
					right=true;
					return true;

				case KEY_UP:
					up=true;
					return true;

				case KEY_DOWN:
					down=true;
					return true;

				case KEY_KEY_Z:
					button1=true;
					return true;
				}
			}
			else
			{
				switch(event.KeyInput.Key)
				{
				case KEY_LEFT:
					left = false;
					return true;

				case KEY_RIGHT:
					right = false;
					return true;

				case KEY_UP:
					up = false;
					return true;

				case KEY_DOWN:
					down = false;
					return true;
				}
			}
		}

		return false;
	}
};

int main()
{
	MyEventReceiver receiver;

	video::E_DRIVER_TYPE driverType;

	driverType = video::EDT_SOFTWARE;

	IrrlichtDevice *device = createDevice(driverType,
		core::dimension2d<s32>(640, 480), 16,false,false,false,&receiver);

	if (device == 0)
		return 1;

	device->setWindowCaption(L"iKIwKX gamedev@2ch");

	video::IVideoDriver* driver = device->getVideoDriver();

	video::ITexture* images = driver->getTexture("all256.bmp");
	driver->makeColorKeyTexture(images, core::position2d<s32>(0,0));

	video::ITexture* imagesLogo = driver->getTexture("gamdev.bmp");

	//tHgݒ
	gui::IGUIFont* font = device->getGUIEnvironment()->getBuiltInFont();

	//\摜̐ݒ
	core::rect<s32> jiki1(0,24,15,39);
	core::rect<s32> jiki2(0,40,15,55);
	core::rect<s32> teki(16,72,31,88);
	core::rect<s32> Logo(0,0,449,119);
	core::rect<s32> tama(16,24,31,39);

	//C[v
	while(device->run() && driver)
	{
		if (device->isWindowActive())
		{
			u32 time = device->getTimer()->getTime();

			driver->beginScene(true, true, video::SColor(0,120,102,136));

			// L[씽f
			if (left && jikix > 0)
				jikix--;
			if (right && jikix < 639-16)
				jikix++;
			if (up && jikiy > 0)
				jikiy--;
			if (down && jikiy <479-16)
				jikiy++;

			//e
			if (button1)
			{
				if (canFire)
				{
					tamax=jikix;
					tamay=jikiy;
					canFire=false;
				}
				button1=false;
			}
			tamay--;
			if (tamay<0)
				canFire=true;

			//Gړ
			tekiy++;
			if (tekiy>479)
				tekiy=0;

			//S\
			driver->draw2DImage(imagesLogo, core::position2d<s32>(0,0),
				Logo, 0, 
				video::SColor(255,255,255,255), true);

			// @`
			driver->draw2DImage(images, core::position2d<s32>(jikix,jikiy),
				(time/500 % 2) ? jiki1 : jiki2, 0, 
				video::SColor(255,255,255,255), true);

			//e`
			driver->draw2DImage(images, core::position2d<s32>(tamax,tamay),
				tama , 0, 
				video::SColor(255,255,255,255), true);

			//G`
			driver->draw2DImage(images, core::position2d<s32>(tekix,tekiy),
				teki , 0, 
				video::SColor(255,255,255,255), true);

			// eLXg\
			if (font)
			font->draw(L"gamedev@2ch", 
				core::rect<s32>(580,470,640,480),
				video::SColor(255,255,255,255));


			driver->endScene();
		}
	}

	device->drop();

	return 0;
}
